#include "jaeil.H"


/****************************************************************************/
/**************************** Init_data.c ***********************************/
/****************************************************************************/
void init_pool(int *size)
{
	int i;
	//Itempool initialize
	assert(pool.is_used = (int *) calloc(*size, sizeof(int )));
  assert(pool.itemid = (int *) calloc(*size, sizeof(int )));
  assert(pool.Y = (int *) calloc(*size, sizeof(int )));
  assert(pool.X = (int *) calloc(*size, sizeof(int )));
  assert(pool.Z = (int *) calloc(*size, sizeof(int )));
	assert(pool.S = (double *) calloc(*size, sizeof(double )));

	//Sorting purpose
	for(i=0; i<*size;i++)
	{
		pool.is_used[i]=0;
		pool.itemid[i]=i;
	}
}

void init_values(int *p, int *k, int *nstr, int *M)
{
  int i;
  /* prior Setting*/  
  prior.Mbeta1=0;
  prior.Vbeta1=5;
  
  for(i=0;i<*p;i++) prior.Mbeta2[i] =0;
  prior.Vbeta2=5;  
  
	for(i=1;i<param.ksize-1;i++)
	{
		prior.MPhi[i]=0;
	}
	prior.VPhi=4;
	

  /* Initial result Setting*/  
  trparam.beta1[0] = 1;
  for(i=0;i<trparam.np;i++) trparam.beta2[i][0]     =   0;
  for(i=1;i<trparam.ksize;i++) trparam.phi[i][0] =    1.0/(double)(trparam.ksize-1) * i;  

}

void init_prior(int *p, int *k, int *nstr, int *M)
{
	int i ;
	
  /* Vector size determination*/
  prior.np = *p;						//Z
  prior.ksize =*k;					//Max within Class

  assert(prior.Mbeta2 = (double *) calloc(prior.np, sizeof(double )));
  assert(prior.Gprob = (double *) calloc(prior.ksize, sizeof(double )));
	assert(prior.MPhi  = (double *) calloc(prior.ksize, sizeof(double )));

  /* Fix Gprob as the same */
  for(i=0; i<prior.ksize; i++) prior.Gprob[i]=1;
}

/* Parameter Initialize*/
void init_param(int *p, int *k, int *nstr, int *M) {
  int i;
  
  /* Vector size determination*/
  param.np = *p;						//Z
  param.ksize =*k;					//Max within Class
  
  /* Regression Parameters */
  assert(param.beta2 = (double *) calloc(param.np, sizeof(double )));
  assert(param.gamma = (double *) calloc(param.ksize, sizeof(double )));
  assert(param.phi = (double *)   calloc(param.ksize, sizeof(double )));
  
  /*  Temprary Usage*/  
  assert(param.Dij = (double **) calloc(*nstr, sizeof(double *)));
  for(i=0;i<*nstr;i++) assert(param.Dij[i] = (double *) calloc(*M, sizeof(double)));

  assert(param.tmpZ  = (double *) calloc(param.np, sizeof(double )));
}

 /* Parameter Initialize*/
void init_trparam(int *p, int *k, int *nstr, int *M) {
  int i;
  
  /* Vector size determination*/
  trparam.np = *p;						//Z
  trparam.ksize =*k;					//Max within Class
  
  /* Regression Parameters */
  assert(trparam.beta1 = (double *) calloc(MAX_ITER, sizeof(double )));
	assert(trparam.DIC = (double *) calloc((MAX_ITER-BURN), sizeof(double ))); 
  
  assert(trparam.beta2 = (double **) calloc(trparam.np, sizeof(double *)));
  for(i=0;i<trparam.np;i++) assert(trparam.beta2[i] = (double *) calloc(MAX_ITER, sizeof(double)));

  assert(trparam.gamma = (double **) calloc(trparam.ksize, sizeof(double *)));
  for(i=0;i<trparam.ksize;i++) assert(trparam.gamma[i] = (double *) calloc(MAX_ITER, sizeof(double)));

  assert(trparam.phi = (double **) calloc(trparam.ksize, sizeof(double *)));
  for(i=0;i<trparam.ksize;i++) assert(trparam.phi[i] = (double *) calloc(MAX_ITER, sizeof(double)));

}

/* DATA Structure Initialize*/
void init_DATA(int *nstr, int *M, int *p) {
  int i, j;
    
  /* The size of data allocation*/
  data.ntot = *nstr * (*M);
  data.nN = *nstr ;
  data.nM = *M;
  data.p  = *p;
  
  /* data initialize */
  assert(data.Y = (int **) calloc(*nstr, sizeof(int *)));
  for(i=0;i<*nstr;i++) assert(data.Y[i] = (int *) calloc(*M, sizeof(int)));
  assert(data.R = (int **) calloc(*nstr, sizeof(int *)));
  for(i=0;i<*nstr;i++) assert(data.R[i] = (int *) calloc(*M, sizeof(int)));
  assert(data.X = (double **) calloc(*nstr, sizeof(double *)));
  for(i=0;i<*nstr;i++) assert(data.X[i] = (double *) calloc(*M, sizeof(double)));
  assert(data.S = (double **) calloc(*nstr, sizeof(double *)));
  for(i=0;i<*nstr;i++) assert(data.S[i] = (double *) calloc(*M, sizeof(double)));

  /* 3-dim initialize */
  assert(data.Z = (double ***) calloc(*nstr, sizeof(double **)));
  for(i=0;i<*nstr;i++) 
  {	
  	assert(data.Z[i] = (double **) calloc(*M, sizeof(double *)));
  	for(j=0;j<*M;j++) assert(data.Z[i][j] = (double *) calloc(*p, sizeof(double)));
  }
  
}

void free_param(int *nstr) 
{
  int i;
  
  free(param.beta2);
  free(param.gamma);
  free(param.phi);
  
  free(param.tmpZ);
  
  for(i=0;i<*nstr;i++) 
	{
		free(param.Dij[i]);
	}
  
  free(param.Dij);
}
void free_prior()
{
  free(prior.Mbeta2);
  free(prior.Gprob);
	free(prior.MPhi);
}

void free_trparam(int *nstr) 
{
  int i;
  
  for(i=0;i<trparam.np;i++) 
		free(trparam.beta2[i]);
  free(trparam.beta2);
  
  for(i=0;i<trparam.ksize;i++) free(trparam.gamma[i]);
  free(trparam.gamma);

	for(i=0;i<trparam.ksize;i++) free(trparam.phi[i]);
  free(trparam.phi);
	
	free(trparam.beta1);
	free(trparam.DIC);

}

void free_data(int *nstr, int *M) 
{
  int i, j;

  for(i=0;i<*nstr;i++) free(data.Y[i]);
  free(data.Y);
  for(i=0;i<*nstr;i++) free(data.R[i]);
  free(data.R);
  for(i=0;i<*nstr;i++) free(data.X[i]);
  free(data.X);
  for(i=0;i<*nstr;i++) free(data.S[i]);
  free(data.S);

  for(i=0;i<*nstr;i++) 
  {	
  	for(j=0;j<(*M);j++) 
  	{	
  		free(data.Z[i][j]);
  	}
  	free(data.Z[i]);
  }
  free(data.Z);
}

void read_pool(FILE *fp, int *nsize) 
{
	int i;
	char buf[_MAX_BUF_];
	init_pool(nsize);
  
	for(i=0;i<*nsize;i++) 
	{
		fscanf(fp,"%s",buf);
		pool.Y[i] = atoi(buf); 

		fscanf(fp,"%s",buf);
		pool.X[i] = atoi(buf); 

		fscanf(fp,"%s",buf);
		pool.Z[i] = atoi(buf); 

		fscanf(fp,"%s",buf);
		pool.S[i] = atof(buf); 

	}
	pool.maxY=vec_max(pool.Y, *nsize);
}

/* Data read : File, num_str, MAX, dim(Z)*/
void read_data(FILE *fp, int *nN, int *nM, int *p) 
{
  int i,j, k;
  char buf[_MAX_BUF_];
  init_DATA(nN, nM, p); 
  
  for(i=0;i<*nN;i++) 
  {
  	for(j=0;j<*nM;j++)
  	{
      fscanf(fp,"%s",buf);
      data.Y[i][j] = atoi(buf); 

      fscanf(fp,"%s",buf);
      data.X[i][j] = atof(buf); 
      
	    if (data.X[i][j]<0)
	    	data.R[i][j]=0;
	    else 
	    	data.R[i][j]=1;
	    	
	    for(k=0;k<*p;k++) 
	    {
        fscanf(fp,"%s",buf);
        data.Z[i][j][k] = atof(buf); 
	    }
      //fscanf(fp,"%s",buf);
      //data.S[i][j] = atof(buf); 
	  }
  }
  
	/* Data verification */
  for(i=0;i<*nN;i++) 
  {
  	for(j=0;j<*nM;j++)
  	{
      printf("%d %f %d %f\n", data.Y[i][j], data.X[i][j], data.R[i][j], data.Z[i][j][0] );
			if (data.R[i][j]==0) data.nMissing+=1;
    }
  }
	/* Missing M management */
  assert(data.mX = (double **) calloc(data.nMissing, sizeof(double *)));
  for(i=0;i<data.nMissing;i++) assert(data.mX[i] = (double *) calloc(MAX_ITER, sizeof(double)));
}

void free_pool()
{
  free(pool.is_used);
  free(pool.itemid);
  free(pool.Y);
  free(pool.X);
	free(pool.Z);
	free(pool.S);

}

void data_allocation2(int *ncase, int *ratio, int nstep)
{
	int i, j, sel_Num; 
	int samsize;
	samsize =*ncase * (*ratio);
	sel_Num = samsize*2 * nstep;

	for(i=0;i<samsize;i++)
	{
		j=i*2;
		data.Y[i][0]=pool.Y[sel_Num+j];
		data.X[i][0]=(double)pool.X[sel_Num+j];
		data.Z[i][0][0]=(double)pool.Z[sel_Num+j];
		if (data.X[i][0]>-1.0) data.R[i][0]=1;
		data.S[i][0] = pool.S[sel_Num+j];
		j=i*2+1;
		data.Y[i][1]=pool.Y[sel_Num+j];
		data.X[i][1]=(double)pool.X[sel_Num+j];
		data.Z[i][1][0]=(double)pool.Z[sel_Num+j];
		if (data.X[i][1]>-1.0) data.R[i][1]=1;
		data.S[i][1] = pool.S[sel_Num+j];
	}

	/* Data verification */
	for(i=0;i<*ncase;i++) 
	{
		for(j=0;j<(*ratio+1);j++)
		{
		  printf("%d %f %d %f \n", data.Y[i][j], data.X[i][j], data.R[i][j], data.Z[i][j][0]);
				if (data.R[i][j]==0) data.nMissing+=1;
		}
	}
}


