#include "jaeil.H"

/****************************************************************************/
/**************************** likelihood.c ***********************************/
/****************************************************************************/

/* Temprarily save the current value to param*/
void value_trans(int nstep)
{
  int i;
  param.beta1 = trparam.beta1[nstep];
  for(i=0;i<param.np;i++) param.beta2[i]=trparam.beta2[i][nstep];
	for(i=0;i<param.ksize;i++) param.phi[i]=trparam.phi[i][nstep];
}

/*
double arms_beta1(double x, int nopt)
{
	int i, j;
	double tmp    = 0.0;
	double tmpNum1 = 0.0;
	double tmpDen1 = 0.0;
	double tmpBuf=0.0;

	
	param.beta1=x;
  for(i=0;i<data.nN;i++) tmp += param.phi[data.Y[i][0]]*data.X[i][0];
  tmpNum1 =  - 1/(2*pow(prior.Vbeta1,2))*pow(param.beta1 - prior.Mbeta1 - tmp*pow(prior.Vbeta1,2) ,2);
  tmp=0.0;
  tmpDen1=0;
  for(i=0;i<data.nN;i++)
  {
		tmp=0.0;
    for(j=0;j<data.nM;j++) 
		{	
			//tmp+= exp(param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][j], param.np) + data.X[i][j]*param.beta1));
			tmp+= exp(param.phi[data.Y[i][0]]*(param.beta2[0]*data.Z[i][j][0] + data.X[i][j]*param.beta1));
		}
    tmpDen1+=log(tmp);
  }

	return ( tmpNum1 - tmpDen1 );
}

double arms_beta2(double x, int nopt)
{
	int i, j;
	double tmp    = 0.0;
	double tmpNum1 = 0.0;
	double tmpDen1 = 0.0;
	double tmpBuf=0.0;
	
	param.beta2[0]=x;
  for(i=0;i<data.nN;i++) tmp += param.phi[data.Y[i][0]]*data.Z[i][0][0];
  tmpNum1 =  - 1/(2*pow(prior.Vbeta2,2))*pow(param.beta2[0] - prior.Mbeta2[0] - tmp*pow(prior.Vbeta2,2) ,2);
  tmp=0.0;
  tmpDen1=0;
  for(i=0;i<data.nN;i++)
  {
		tmp=0.0;
    for(j=0;j<data.nM;j++) 
		{	
			//tmp+= exp(param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][j], param.np) + data.X[i][j]*param.beta1));
			tmp+= exp(param.phi[data.Y[i][0]]*(param.beta2[0]*data.Z[i][j][0] + data.X[i][j]*param.beta1));

		}
    tmpDen1+=log(tmp);
  }
	return ( tmpNum1 - tmpDen1 );
}
*/

double arms_beta1(double x, int nopt)
{
	int i, j;
	double tmp    = 0.0;
	double tmpNum1 = 0.0;
	double tmpDen1 = 0.0;
	double tmpBuf=0.0;
	
	param.beta1=x;
  for(i=0;i<data.nN;i++) tmp += param.phi[data.Y[i][0]]*data.X[i][0];
  tmpNum1 =  - 1/(2*pow(prior.Vbeta1,2))*pow(param.beta1 - prior.Mbeta1 - tmp*pow(prior.Vbeta1,2) ,2);
  tmp=0.0;
  tmpDen1=0;
  for(i=0;i<data.nN;i++)
  {
		tmp=0.0;
    for(j=0;j<data.nM;j++) 		
		{	
			tmpBuf = param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][0], param.np) + data.X[i][0]*param.beta1)-5;
			tmp+= exp(param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][j], param.np) + data.X[i][j]*param.beta1)-tmpBuf);
		}
    tmpDen1+=tmpBuf+log(tmp);

  }

	return ( tmpNum1 - tmpDen1 );
}

double arms_beta2(double x, int nopt)
{
	int i, j;
	double tmp    = 0.0;
	double tmpNum1 = 0.0;
	double tmpDen1 = 0.0;
	double tmpBuf=0.0;
	
	param.beta2[0]=x;
  for(i=0;i<data.nN;i++) tmp += param.phi[data.Y[i][0]]*data.Z[i][0][0];
  tmpNum1 =  - 1/(2*pow(prior.Vbeta2,2))*pow(param.beta2[0] - prior.Mbeta2[0] - tmp*pow(prior.Vbeta2,2) ,2);
  tmp=0.0;
  tmpDen1=0;
  for(i=0;i<data.nN;i++)
  {
		tmp=0.0;
    for(j=0;j<data.nM;j++) 		
		{	
			tmpBuf = param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][0], param.np) + data.X[i][0]*param.beta1)-5;
			tmp+= exp(param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][j], param.np) + data.X[i][j]*param.beta1)-tmpBuf);
		}
    tmpDen1+=tmpBuf+log(tmp);

  }
	return ( tmpNum1 - tmpDen1 );
}


double arms_Gamma(double x, int nopt)
{
	int i, j,k;
	double tmp    = 0.0;
	double tmpNum1 = 0.0;
	double tmpDen1 = 0.0;
	double tmpBuf=0.0;

	k=nopt;
	tmp=0.0;
	param.phi[k] =x;

  for(i=0;i<data.nN;i++) 
	{
		//if(data.Y[i][0]==k) tmp += vec2_sum(param.beta2, data.Z[i][0], param.np)+data.X[i][0]*param.beta1;
		if(data.Y[i][0]==k) tmp += param.beta2[0]*data.Z[i][0][0]+data.X[i][0]*param.beta1;
	}
  tmpNum1 =  - 1/(2*pow(prior.VPhi ,2))*pow(param.phi[k] - prior.MPhi[k] - tmp*pow(prior.VPhi ,2) ,2);
	  
	tmp=0.0;
	tmpDen1=0;
	for(i=0;i<data.nN;i++)
	{
			tmp=0.0;
			for(j=0;j<data.nM;j++) 
			{	
				//tmp+= exp(param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][j], param.np) + data.X[i][j]*param.beta1));
				tmp+= exp(param.phi[data.Y[i][0]]*(param.beta2[0]*data.Z[i][j][0] + data.X[i][j]*param.beta1));
			}
			tmpDen1+=log(tmp);
	}
	return ( tmpNum1 - tmpDen1 );
}

double Calc_DIC(int nstep)
{
	int i, j;
	double tmp    = 0.0;
	double tmpNum1 = 0.0;
	double tmpDen1 = 0.0;
	tmp=0;
	for(i=0;i<data.nN;i++) 
	{
		tmp += param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][0], param.np) + data.X[i][0]*param.beta1 )  ;
	}
	tmpNum1 = tmp;

	tmp=0.0;
	tmpDen1=0;
	for(i=0;i<data.nN;i++)
	{
		tmp=0;
		for(j=0;j<data.nM;j++) tmp+= exp(param.phi[data.Y[i][0]]*(vec2_sum(param.beta2, data.Z[i][j], param.np) + data.X[i][j]*param.beta1  )) ;
			tmpDen1 +=log(tmp);
	}
	return 2*(tmpDen1-tmpNum1);
}

//Modified : Unorderd case, we use phi itself.
/**************************************/
/*** Metropolis-Hastings with Gibbs ***/
/**************************************/
void mhgibbs(int nsimul)
{
	//initial setting for ARMS
  int err, ninit = 4, npoint = 100, nsamp = 1, ncent = 4 ;
  int neval;
  double xinit[10]={-1.0,-0.5, 0.5,1.0}, xl = -4.0, xr =10.0;
	double yl=-4.5, yr=4.5;
  double xsamp[100], xcent[10], qcent[10] = {5., 30., 70., 95.};
  unsigned seed = 44;
  double convex = 1.0;
	double convex2 =0.0;
  int dometrop = 0;			// We know log-concavity
  double xprev = 0.0;

  int j, k;
  
  /* MH-Gibbs Iteration Start*/
  for(k=0;k<MAX_ITER-1;k++)
  {
		value_trans(k);
		
		printf("%dth :Iteraion # %d \n" ,nsimul , k);		

		xprev =trparam.beta1[k];
		err=arms(xinit,ninit,&xl,&xr,arms_beta1 ,&convex2, npoint,dometrop,&xprev,xsamp,nsamp,qcent,xcent,ncent,&neval, 0);
		trparam.beta1[k+1]=xsamp[0];
		param.beta1=xsamp[0]; 

		xprev =trparam.beta2[0][k];
		err=arms(xinit,ninit,&xl,&xr,arms_beta2 ,&convex2, npoint,dometrop,&xprev,xsamp,nsamp,qcent,xcent,ncent,&neval, 0);
		trparam.beta2[0][k+1]=xsamp[0];
		param.beta2[0]=xsamp[0];

		/* Gamma*/
		for(j=1;j<param.ksize;j++)
		{
			if(j==param.ksize-1)
			{
				param.phi[j]=1;
				trparam.phi[j][k+1]=1;
			}else{
				xprev =trparam.phi[j][k];
				err=arms(xinit,ninit,&yl,&yr,arms_Gamma ,&convex2, npoint,0,&xprev,xsamp,nsamp,qcent,xcent,ncent,&neval, j);
				trparam.phi[j][k+1]=xsamp[0];
				param.phi[j]=xsamp[0];
			}
		}
		if(k>=BURN) trparam.DIC[k-BURN] = Calc_DIC(k);

    if(err>0){
      printf("Error Occurs at %d\n", err);
			system("PAUSE");
      exit(1);
    }
  }
}



